#include "mainwindow.h"

#include "sellerdialog.h"

MainWindow::MainWindow()
{
    ui_.setupUi(this);

    connect(ui_.actionQuit, &QAction::triggered, qApp, QApplication::quit);
    connect(ui_.actionEditSeller, &QAction::triggered, this, &MainWindow::on_actionEditSeller_triggered);

    marketplace_ = std::make_unique<Marketplace>();
}

void MainWindow::on_actionEditSeller_triggered()
{
    auto dialog = std::make_unique<SellerDialog>(this);
    int retCode = dialog->exec();
    if (retCode == QDialog::Accepted) {
        marketplace_->storeToDb();
    } else {
        marketplace_->loadFromDb();
    }
}